Package org.springframework.beans.factory.support

# Class AbstractBeanDefinitionReader

java.lang.Object
org.springframework.beans.factory.support.AbstractBeanDefinitionReader

All Implemented Interfaces:
  `BeanDefinitionReader`, `org.springframework.core.env.EnvironmentCapable`

Direct Known Subclasses:
  `GroovyBeanDefinitionReader`, `PropertiesBeanDefinitionReader`, `XmlBeanDefinitionReader`

public abstract class AbstractBeanDefinitionReader extends Object implements BeanDefinitionReader, org.springframework.core.env.EnvironmentCapable
Abstract base class for bean definition readers which implement the `BeanDefinitionReader` interface.

Provides common properties like the bean factory to work on and the class loader to use for loading bean classes.

Since:
  11.12.2003
Author:
  Juergen Hoeller, Chris Beams
See Also:
  - `BeanDefinitionReaderUtils`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final org.apache.commons.logging.Log`
`logger`
Logger available to subclasses.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`AbstractBeanDefinitionReader(BeanDefinitionRegistry registry)`
Create a new AbstractBeanDefinitionReader for the given bean factory.

## Method Summary

Modifier and Type
Method
Description
`ClassLoader`
`getBeanClassLoader()`
Return the class loader to use for bean classes.
`BeanNameGenerator`
`getBeanNameGenerator()`
Return the `BeanNameGenerator` to use for anonymous beans (without explicit bean name specified).
`org.springframework.core.env.Environment`
`getEnvironment()`
`final BeanDefinitionRegistry`
`getRegistry()`
Return the bean factory to register the bean definitions with.
`org.springframework.core.io.ResourceLoader`
`getResourceLoader()`
Return the `ResourceLoader` to use for resource locations.
`int`
`loadBeanDefinitions(String location)`
Load bean definitions from the specified resource location.
`int`
`loadBeanDefinitions(String... locations)`
Load bean definitions from the specified resource locations.
`int`
`loadBeanDefinitions(String location, Set<org.springframework.core.io.Resource> actualResources)`
Load bean definitions from the specified resource location.
`int`
`loadBeanDefinitions(org.springframework.core.io.Resource... resources)`
Load bean definitions from the specified resources.
`void`
`setBeanClassLoader(ClassLoader beanClassLoader)`
Set the ClassLoader to use for bean classes.
`void`
`setBeanNameGenerator(BeanNameGenerator beanNameGenerator)`
Set the BeanNameGenerator to use for anonymous beans (without explicit bean name specified).
`void`
`setEnvironment(org.springframework.core.env.Environment environment)`
Set the Environment to use when reading bean definitions.
`void`
`setResourceLoader(org.springframework.core.io.ResourceLoader resourceLoader)`
Set the ResourceLoader to use for resource locations.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.springframework.beans.factory.support.BeanDefinitionReader

`loadBeanDefinitions`

## Field Details

### logger

protected final org.apache.commons.logging.Log logger
Logger available to subclasses.

## Constructor Details

### AbstractBeanDefinitionReader

protected AbstractBeanDefinitionReader(BeanDefinitionRegistry registry)
Create a new AbstractBeanDefinitionReader for the given bean factory.

If the passed-in bean factory does not only implement the BeanDefinitionRegistry interface but also the ResourceLoader interface, it will be used as default ResourceLoader as well. This will usually be the case for `org.springframework.context.ApplicationContext` implementations.

If given a plain BeanDefinitionRegistry, the default ResourceLoader will be a `PathMatchingResourcePatternResolver`.

If the passed-in bean factory also implements `EnvironmentCapable` its environment will be used by this reader. Otherwise, the reader will initialize and use a `StandardEnvironment`. All ApplicationContext implementations are EnvironmentCapable, while normal BeanFactory implementations are not.

Parameters:
  `registry` - the BeanFactory to load bean definitions into, in the form of a BeanDefinitionRegistry
See Also:
  - `setResourceLoader(org.springframework.core.io.ResourceLoader)`
  - `setEnvironment(org.springframework.core.env.Environment)`

## Method Details

### getRegistry

public final BeanDefinitionRegistry getRegistry()
Description copied from interface: `BeanDefinitionReader`
Return the bean factory to register the bean definitions with.

The factory is exposed through the `BeanDefinitionRegistry` interface, encapsulating the methods that are relevant for bean definition handling.

Specified by:
  `getRegistry` in interface `BeanDefinitionReader`

### setResourceLoader

public void setResourceLoader(@Nullable org.springframework.core.io.ResourceLoader resourceLoader)
Set the ResourceLoader to use for resource locations. If specifying a ResourcePatternResolver, the bean definition reader will be capable of resolving resource patterns to Resource arrays.

Default is PathMatchingResourcePatternResolver, also capable of resource pattern resolving through the ResourcePatternResolver interface.

Setting this to `null` suggests that absolute resource loading is not available for this bean definition reader.

See Also:
  - `ResourcePatternResolver`
  - `PathMatchingResourcePatternResolver`

### getResourceLoader

@Nullable public org.springframework.core.io.ResourceLoader getResourceLoader()
Description copied from interface: `BeanDefinitionReader`
Return the `ResourceLoader` to use for resource locations.

Can be checked for the `ResourcePatternResolver` interface and cast accordingly, for loading multiple resources for a given resource pattern.

A `null` return value suggests that absolute resource loading is not available for this bean definition reader.

This is mainly meant to be used for importing further resources from within a bean definition resource, for example via the "import" tag in XML bean definitions. It is recommended, however, to apply such imports relative to the defining resource; only explicit full resource locations will trigger absolute path based resource loading.

There is also a `loadBeanDefinitions(String)` method available, for loading bean definitions from a resource location (or location pattern). This is a convenience to avoid explicit `ResourceLoader` handling.

Specified by:
  `getResourceLoader` in interface `BeanDefinitionReader`
See Also:
  - `BeanDefinitionReader.loadBeanDefinitions(String)`
  - `ResourcePatternResolver`

### setBeanClassLoader

public void setBeanClassLoader(@Nullable ClassLoader beanClassLoader)
Set the ClassLoader to use for bean classes.

Default is `null`, which suggests to not load bean classes eagerly but rather to just register bean definitions with class names, with the corresponding Classes to be resolved later (or never).

See Also:
  - `Thread.getContextClassLoader()`

### getBeanClassLoader

@Nullable public ClassLoader getBeanClassLoader()
Description copied from interface: `BeanDefinitionReader`
Return the class loader to use for bean classes.

`null` suggests to not load bean classes eagerly but rather to just register bean definitions with class names, with the corresponding classes to be resolved later (or never).

Specified by:
  `getBeanClassLoader` in interface `BeanDefinitionReader`

### setEnvironment

public void setEnvironment(org.springframework.core.env.Environment environment)
Set the Environment to use when reading bean definitions. Most often used for evaluating profile information to determine which bean definitions should be read and which should be omitted.

### getEnvironment

public org.springframework.core.env.Environment getEnvironment()

Specified by:
  `getEnvironment` in interface `org.springframework.core.env.EnvironmentCapable`

### setBeanNameGenerator

public void setBeanNameGenerator(@Nullable BeanNameGenerator beanNameGenerator)
Set the BeanNameGenerator to use for anonymous beans (without explicit bean name specified).

Default is a `DefaultBeanNameGenerator`.

### getBeanNameGenerator

public BeanNameGenerator getBeanNameGenerator()
Description copied from interface: `BeanDefinitionReader`
Return the `BeanNameGenerator` to use for anonymous beans (without explicit bean name specified).

Specified by:
  `getBeanNameGenerator` in interface `BeanDefinitionReader`

### loadBeanDefinitions

public int loadBeanDefinitions(org.springframework.core.io.Resource... resources) throws BeanDefinitionStoreException
Description copied from interface: `BeanDefinitionReader`
Load bean definitions from the specified resources.

Specified by:
  `loadBeanDefinitions` in interface `BeanDefinitionReader`
Parameters:
  `resources` - the resource descriptors
Returns:
  the number of bean definitions found
Throws:
  `BeanDefinitionStoreException` - in case of loading or parsing errors

### loadBeanDefinitions

public int loadBeanDefinitions(String location) throws BeanDefinitionStoreException
Description copied from interface: `BeanDefinitionReader`
Load bean definitions from the specified resource location.

The location can also be a location pattern, provided that the `ResourceLoader` of this bean definition reader is a `ResourcePatternResolver`.

Specified by:
  `loadBeanDefinitions` in interface `BeanDefinitionReader`
Parameters:
  `location` - the resource location, to be loaded with the `ResourceLoader` (or `ResourcePatternResolver`) of this bean definition reader
Returns:
  the number of bean definitions found
Throws:
  `BeanDefinitionStoreException` - in case of loading or parsing errors
See Also:
  - `BeanDefinitionReader.getResourceLoader()`
  - `BeanDefinitionReader.loadBeanDefinitions(org.springframework.core.io.Resource)`
  - `BeanDefinitionReader.loadBeanDefinitions(org.springframework.core.io.Resource[])`

### loadBeanDefinitions

public int loadBeanDefinitions(String location, @Nullable Set<org.springframework.core.io.Resource> actualResources) throws BeanDefinitionStoreException
Load bean definitions from the specified resource location.

The location can also be a location pattern, provided that the ResourceLoader of this bean definition reader is a ResourcePatternResolver.

Parameters:
  `location` - the resource location, to be loaded with the ResourceLoader (or ResourcePatternResolver) of this bean definition reader
  `actualResources` - a Set to be filled with the actual Resource objects that have been resolved during the loading process. May be `null` to indicate that the caller is not interested in those Resource objects.
Returns:
  the number of bean definitions found
Throws:
  `BeanDefinitionStoreException` - in case of loading or parsing errors
See Also:
  - `getResourceLoader()`
  - `BeanDefinitionReader.loadBeanDefinitions(org.springframework.core.io.Resource)`
  - `loadBeanDefinitions(org.springframework.core.io.Resource[])`

### loadBeanDefinitions

public int loadBeanDefinitions(String... locations) throws BeanDefinitionStoreException
Description copied from interface: `BeanDefinitionReader`
Load bean definitions from the specified resource locations.

Specified by:
  `loadBeanDefinitions` in interface `BeanDefinitionReader`
Parameters:
  `locations` - the resource locations, to be loaded with the `ResourceLoader` (or `ResourcePatternResolver`) of this bean definition reader
Returns:
  the number of bean definitions found
Throws:
  `BeanDefinitionStoreException` - in case of loading or parsing errors